﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Collections.ObjectModel;

namespace xamDataGridTabSkip
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<Person> data = new ObservableCollection<Person>();
            data.Add(new Person() { Age = 30, FirstName = "John1", LastName = "Doe1", ID = 1 });
            data.Add(new Person() { Age = 40, FirstName = "John2", LastName = "Doe2", ID = 2 });
            data.Add(new Person() { Age = 50, FirstName = "John3", LastName = "Doe3", ID = 3 });
            data.Add(new Person() { Age = 60, FirstName = "John4", LastName = "Doe4", ID = 4 });

            this.DataContext = data;
        }

        private void xamDataGrid1_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            if (e.Cell.Field.AllowEditResolved == false)
            {
                xamDataGrid1.ExecuteCommand(DataPresenterCommands.CellNextByTab);
            }
            if (e.Cell.Field.Index == xamDataGrid1.FieldLayouts[0].Fields.Count - 1 && e.Cell.Record.Index == xamDataGrid1.Records.Count - 1)
            {
                (xamDataGrid1.DataSource as ObservableCollection<Person>).Add(new Person() { Age = 99, FirstName = "John99", LastName = "Doe99", ID = 99 });
                xamDataGrid1.ExecuteCommand(DataPresenterCommands.RecordLastOverall);
                (xamDataGrid1.ActiveRecord as DataRecord).Cells[1].IsActive = true;
                xamDataGrid1.ExecuteCommand(DataPresenterCommands.StartEditMode);                
            }
        }       
    }

    public class Person
    {
        public int Age { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public int ID { get; set; }
    }
}
